# Photos
The long-awaited modern gallery app for your Nextcloud server

[<img alt="Donate using Liberapay" src="https://liberapay.com/assets/widgets/donate.svg" height="40">](https://liberapay.com/nkming2/donate)
[<img src="https://cdn.buymeacoffee.com/buttons/v2/default-yellow.png" alt="Buy Me A Coffee" height="40">](https://www.buymeacoffee.com/nkming2)

## Get the app
### Android
[<img src="https://play.google.com/intl/en_us/badges/static/images/badges/en_badge_web_generic.png" alt="Google Play" width="160" />](https://play.google.com/store/apps/details?id=com.nkming.nc_photos.paid&referrer=utm_source%3Drepo)  
Or the [ad-supported version](https://play.google.com/store/apps/details?id=com.nkming.nc_photos&referrer=utm_source%3Drepo)  
Or download pre-built binary [here](https://gitlab.com/nkming2/nc-photos/-/wikis/Release)

### Web (experimental)
Please read [this guide](https://gitlab.com/nkming2/nc-photos/-/wikis/help/web-app)

### Compile yourself
Please read [this guide](https://gitlab.com/nkming2/nc-photos/-/wikis/development/build)

## Screenshots
<img src="https://gitlab.com/nkming2/nc-photos/-/raw/master/fastlane/metadata/android/en-US/images/phoneScreenshots/1.jpg" width="180" /> <img src="https://gitlab.com/nkming2/nc-photos/-/raw/master/fastlane/metadata/android/en-US/images/phoneScreenshots/2.jpg" width="180" /> <img src="https://gitlab.com/nkming2/nc-photos/-/raw/master/fastlane/metadata/android/en-US/images/phoneScreenshots/3.jpg" width="180" /> <img src="https://gitlab.com/nkming2/nc-photos/-/raw/master/fastlane/metadata/android/en-US/images/phoneScreenshots/4.jpg" width="180" /> <img src="https://gitlab.com/nkming2/nc-photos/-/raw/master/fastlane/metadata/android/en-US/images/phoneScreenshots/5.jpg" width="180" /> <img src="https://gitlab.com/nkming2/nc-photos/-/raw/master/fastlane/metadata/android/en-US/images/phoneScreenshots/6.jpg" width="180" /> <img src="https://gitlab.com/nkming2/nc-photos/-/raw/master/fastlane/metadata/android/en-US/images/phoneScreenshots/7.jpg" width="180" /> <img src="https://gitlab.com/nkming2/nc-photos/-/raw/master/fastlane/metadata/android/en-US/images/phoneScreenshots/8.jpg" width="180" />

Screenshots contain photos by:
- Dillon Kydd on Unsplash
- rawkkim on Unsplash
- Video by Yaroslava Borz from Pexels
- and others

## Features
- EXIF support (JPEG and HEIC only)
- Organize photos with actual albums that are NOT folders
- Reverse geocoding
- [Enhance photos with machine learning models](https://gitlab.com/nkming2/nc-photos/-/wikis/help/enhance)
- [Edit photos with built-in editor](https://gitlab.com/nkming2/nc-photos/-/wikis/help/edit-photos)
- Sign-in to multiple servers
- [Create shared albums with users on the same server (experimental)](https://gitlab.com/nkming2/nc-photos/-/wikis/help/shared-album)

## Supported formats
- JPEG, PNG, WebP, HEIC, GIF
- MP4, WebM (codec support may vary between devices)

## Supported Nextcloud apps
- Face Recognition (require 0.8.5+)
  - Please read [this guide](https://gitlab.com/nkming2/nc-photos/-/wikis/help/people)

## Translations (sorted by ISO name)
- Chinese/中文 (contributed by zerolin)
- Czech/Čeština (contributed by Skyhawk)
- Finnish/Suomi (contributed by pHamala)
- French/Français (contributed by mgreil)
- German/Deutsch (contributed by PhilProg)
- Greek/Ελληνικά (contributed by Chris Karasoulis)
- Polish/Polski (contributed by szymok)
- Portuguese/Português (contributed by fernosan)
- Russian/Русский (contributed by kvasenok, meixnt & eriane)
- Spanish/Español (contributed by luckkmaxx)
- Turkish/Türkçe (contributed by aliyasiny65)

## Contributions, troubleshooting and guides
Please visit the [project wiki](https://gitlab.com/nkming2/nc-photos/-/wikis/home)
